package com.hai.entity;

import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.List;

public class HighChildOrderExample {
    protected String orderByClause;

    protected boolean distinct;

    protected List<Criteria> oredCriteria;

    private Integer limit;

    private Long offset;

    public HighChildOrderExample() {
        oredCriteria = new ArrayList<Criteria>();
    }

    public void setOrderByClause(String orderByClause) {
        this.orderByClause = orderByClause;
    }

    public String getOrderByClause() {
        return orderByClause;
    }

    public void setDistinct(boolean distinct) {
        this.distinct = distinct;
    }

    public boolean isDistinct() {
        return distinct;
    }

    public List<Criteria> getOredCriteria() {
        return oredCriteria;
    }

    public void or(Criteria criteria) {
        oredCriteria.add(criteria);
    }

    public Criteria or() {
        Criteria criteria = createCriteriaInternal();
        oredCriteria.add(criteria);
        return criteria;
    }

    public Criteria createCriteria() {
        Criteria criteria = createCriteriaInternal();
        if (oredCriteria.size() == 0) {
            oredCriteria.add(criteria);
        }
        return criteria;
    }

    protected Criteria createCriteriaInternal() {
        Criteria criteria = new Criteria();
        return criteria;
    }

    public void clear() {
        oredCriteria.clear();
        orderByClause = null;
        distinct = false;
    }

    public void setLimit(Integer limit) {
        this.limit = limit;
    }

    public Integer getLimit() {
        return limit;
    }

    public void setOffset(Long offset) {
        this.offset = offset;
    }

    public Long getOffset() {
        return offset;
    }

    protected abstract static class GeneratedCriteria {
        protected List<Criterion> criteria;

        protected GeneratedCriteria() {
            super();
            criteria = new ArrayList<Criterion>();
        }

        public boolean isValid() {
            return criteria.size() > 0;
        }

        public List<Criterion> getAllCriteria() {
            return criteria;
        }

        public List<Criterion> getCriteria() {
            return criteria;
        }

        protected void addCriterion(String condition) {
            if (condition == null) {
                throw new RuntimeException("Value for condition cannot be null");
            }
            criteria.add(new Criterion(condition));
        }

        protected void addCriterion(String condition, Object value, String property) {
            if (value == null) {
                throw new RuntimeException("Value for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value));
        }

        protected void addCriterion(String condition, Object value1, Object value2, String property) {
            if (value1 == null || value2 == null) {
                throw new RuntimeException("Between values for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value1, value2));
        }

        public Criteria andIdIsNull() {
            addCriterion("id is null");
            return (Criteria) this;
        }

        public Criteria andIdIsNotNull() {
            addCriterion("id is not null");
            return (Criteria) this;
        }

        public Criteria andIdEqualTo(Long value) {
            addCriterion("id =", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotEqualTo(Long value) {
            addCriterion("id <>", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThan(Long value) {
            addCriterion("id >", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThanOrEqualTo(Long value) {
            addCriterion("id >=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThan(Long value) {
            addCriterion("id <", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThanOrEqualTo(Long value) {
            addCriterion("id <=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdIn(List<Long> values) {
            addCriterion("id in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotIn(List<Long> values) {
            addCriterion("id not in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdBetween(Long value1, Long value2) {
            addCriterion("id between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotBetween(Long value1, Long value2) {
            addCriterion("id not between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andOrderIdIsNull() {
            addCriterion("order_id is null");
            return (Criteria) this;
        }

        public Criteria andOrderIdIsNotNull() {
            addCriterion("order_id is not null");
            return (Criteria) this;
        }

        public Criteria andOrderIdEqualTo(Long value) {
            addCriterion("order_id =", value, "orderId");
            return (Criteria) this;
        }

        public Criteria andOrderIdNotEqualTo(Long value) {
            addCriterion("order_id <>", value, "orderId");
            return (Criteria) this;
        }

        public Criteria andOrderIdGreaterThan(Long value) {
            addCriterion("order_id >", value, "orderId");
            return (Criteria) this;
        }

        public Criteria andOrderIdGreaterThanOrEqualTo(Long value) {
            addCriterion("order_id >=", value, "orderId");
            return (Criteria) this;
        }

        public Criteria andOrderIdLessThan(Long value) {
            addCriterion("order_id <", value, "orderId");
            return (Criteria) this;
        }

        public Criteria andOrderIdLessThanOrEqualTo(Long value) {
            addCriterion("order_id <=", value, "orderId");
            return (Criteria) this;
        }

        public Criteria andOrderIdIn(List<Long> values) {
            addCriterion("order_id in", values, "orderId");
            return (Criteria) this;
        }

        public Criteria andOrderIdNotIn(List<Long> values) {
            addCriterion("order_id not in", values, "orderId");
            return (Criteria) this;
        }

        public Criteria andOrderIdBetween(Long value1, Long value2) {
            addCriterion("order_id between", value1, value2, "orderId");
            return (Criteria) this;
        }

        public Criteria andOrderIdNotBetween(Long value1, Long value2) {
            addCriterion("order_id not between", value1, value2, "orderId");
            return (Criteria) this;
        }

        public Criteria andMemIdIsNull() {
            addCriterion("mem_id is null");
            return (Criteria) this;
        }

        public Criteria andMemIdIsNotNull() {
            addCriterion("mem_id is not null");
            return (Criteria) this;
        }

        public Criteria andMemIdEqualTo(Long value) {
            addCriterion("mem_id =", value, "memId");
            return (Criteria) this;
        }

        public Criteria andMemIdNotEqualTo(Long value) {
            addCriterion("mem_id <>", value, "memId");
            return (Criteria) this;
        }

        public Criteria andMemIdGreaterThan(Long value) {
            addCriterion("mem_id >", value, "memId");
            return (Criteria) this;
        }

        public Criteria andMemIdGreaterThanOrEqualTo(Long value) {
            addCriterion("mem_id >=", value, "memId");
            return (Criteria) this;
        }

        public Criteria andMemIdLessThan(Long value) {
            addCriterion("mem_id <", value, "memId");
            return (Criteria) this;
        }

        public Criteria andMemIdLessThanOrEqualTo(Long value) {
            addCriterion("mem_id <=", value, "memId");
            return (Criteria) this;
        }

        public Criteria andMemIdIn(List<Long> values) {
            addCriterion("mem_id in", values, "memId");
            return (Criteria) this;
        }

        public Criteria andMemIdNotIn(List<Long> values) {
            addCriterion("mem_id not in", values, "memId");
            return (Criteria) this;
        }

        public Criteria andMemIdBetween(Long value1, Long value2) {
            addCriterion("mem_id between", value1, value2, "memId");
            return (Criteria) this;
        }

        public Criteria andMemIdNotBetween(Long value1, Long value2) {
            addCriterion("mem_id not between", value1, value2, "memId");
            return (Criteria) this;
        }

        public Criteria andGoodsTypeIsNull() {
            addCriterion("goods_type is null");
            return (Criteria) this;
        }

        public Criteria andGoodsTypeIsNotNull() {
            addCriterion("goods_type is not null");
            return (Criteria) this;
        }

        public Criteria andGoodsTypeEqualTo(Integer value) {
            addCriterion("goods_type =", value, "goodsType");
            return (Criteria) this;
        }

        public Criteria andGoodsTypeNotEqualTo(Integer value) {
            addCriterion("goods_type <>", value, "goodsType");
            return (Criteria) this;
        }

        public Criteria andGoodsTypeGreaterThan(Integer value) {
            addCriterion("goods_type >", value, "goodsType");
            return (Criteria) this;
        }

        public Criteria andGoodsTypeGreaterThanOrEqualTo(Integer value) {
            addCriterion("goods_type >=", value, "goodsType");
            return (Criteria) this;
        }

        public Criteria andGoodsTypeLessThan(Integer value) {
            addCriterion("goods_type <", value, "goodsType");
            return (Criteria) this;
        }

        public Criteria andGoodsTypeLessThanOrEqualTo(Integer value) {
            addCriterion("goods_type <=", value, "goodsType");
            return (Criteria) this;
        }

        public Criteria andGoodsTypeIn(List<Integer> values) {
            addCriterion("goods_type in", values, "goodsType");
            return (Criteria) this;
        }

        public Criteria andGoodsTypeNotIn(List<Integer> values) {
            addCriterion("goods_type not in", values, "goodsType");
            return (Criteria) this;
        }

        public Criteria andGoodsTypeBetween(Integer value1, Integer value2) {
            addCriterion("goods_type between", value1, value2, "goodsType");
            return (Criteria) this;
        }

        public Criteria andGoodsTypeNotBetween(Integer value1, Integer value2) {
            addCriterion("goods_type not between", value1, value2, "goodsType");
            return (Criteria) this;
        }

        public Criteria andGoodsIdIsNull() {
            addCriterion("goods_id is null");
            return (Criteria) this;
        }

        public Criteria andGoodsIdIsNotNull() {
            addCriterion("goods_id is not null");
            return (Criteria) this;
        }

        public Criteria andGoodsIdEqualTo(Long value) {
            addCriterion("goods_id =", value, "goodsId");
            return (Criteria) this;
        }

        public Criteria andGoodsIdNotEqualTo(Long value) {
            addCriterion("goods_id <>", value, "goodsId");
            return (Criteria) this;
        }

        public Criteria andGoodsIdGreaterThan(Long value) {
            addCriterion("goods_id >", value, "goodsId");
            return (Criteria) this;
        }

        public Criteria andGoodsIdGreaterThanOrEqualTo(Long value) {
            addCriterion("goods_id >=", value, "goodsId");
            return (Criteria) this;
        }

        public Criteria andGoodsIdLessThan(Long value) {
            addCriterion("goods_id <", value, "goodsId");
            return (Criteria) this;
        }

        public Criteria andGoodsIdLessThanOrEqualTo(Long value) {
            addCriterion("goods_id <=", value, "goodsId");
            return (Criteria) this;
        }

        public Criteria andGoodsIdIn(List<Long> values) {
            addCriterion("goods_id in", values, "goodsId");
            return (Criteria) this;
        }

        public Criteria andGoodsIdNotIn(List<Long> values) {
            addCriterion("goods_id not in", values, "goodsId");
            return (Criteria) this;
        }

        public Criteria andGoodsIdBetween(Long value1, Long value2) {
            addCriterion("goods_id between", value1, value2, "goodsId");
            return (Criteria) this;
        }

        public Criteria andGoodsIdNotBetween(Long value1, Long value2) {
            addCriterion("goods_id not between", value1, value2, "goodsId");
            return (Criteria) this;
        }

        public Criteria andGoodsNameIsNull() {
            addCriterion("goods_name is null");
            return (Criteria) this;
        }

        public Criteria andGoodsNameIsNotNull() {
            addCriterion("goods_name is not null");
            return (Criteria) this;
        }

        public Criteria andGoodsNameEqualTo(String value) {
            addCriterion("goods_name =", value, "goodsName");
            return (Criteria) this;
        }

        public Criteria andGoodsNameNotEqualTo(String value) {
            addCriterion("goods_name <>", value, "goodsName");
            return (Criteria) this;
        }

        public Criteria andGoodsNameGreaterThan(String value) {
            addCriterion("goods_name >", value, "goodsName");
            return (Criteria) this;
        }

        public Criteria andGoodsNameGreaterThanOrEqualTo(String value) {
            addCriterion("goods_name >=", value, "goodsName");
            return (Criteria) this;
        }

        public Criteria andGoodsNameLessThan(String value) {
            addCriterion("goods_name <", value, "goodsName");
            return (Criteria) this;
        }

        public Criteria andGoodsNameLessThanOrEqualTo(String value) {
            addCriterion("goods_name <=", value, "goodsName");
            return (Criteria) this;
        }

        public Criteria andGoodsNameLike(String value) {
            addCriterion("goods_name like", value, "goodsName");
            return (Criteria) this;
        }

        public Criteria andGoodsNameNotLike(String value) {
            addCriterion("goods_name not like", value, "goodsName");
            return (Criteria) this;
        }

        public Criteria andGoodsNameIn(List<String> values) {
            addCriterion("goods_name in", values, "goodsName");
            return (Criteria) this;
        }

        public Criteria andGoodsNameNotIn(List<String> values) {
            addCriterion("goods_name not in", values, "goodsName");
            return (Criteria) this;
        }

        public Criteria andGoodsNameBetween(String value1, String value2) {
            addCriterion("goods_name between", value1, value2, "goodsName");
            return (Criteria) this;
        }

        public Criteria andGoodsNameNotBetween(String value1, String value2) {
            addCriterion("goods_name not between", value1, value2, "goodsName");
            return (Criteria) this;
        }

        public Criteria andGoodsImgIsNull() {
            addCriterion("goods_img is null");
            return (Criteria) this;
        }

        public Criteria andGoodsImgIsNotNull() {
            addCriterion("goods_img is not null");
            return (Criteria) this;
        }

        public Criteria andGoodsImgEqualTo(String value) {
            addCriterion("goods_img =", value, "goodsImg");
            return (Criteria) this;
        }

        public Criteria andGoodsImgNotEqualTo(String value) {
            addCriterion("goods_img <>", value, "goodsImg");
            return (Criteria) this;
        }

        public Criteria andGoodsImgGreaterThan(String value) {
            addCriterion("goods_img >", value, "goodsImg");
            return (Criteria) this;
        }

        public Criteria andGoodsImgGreaterThanOrEqualTo(String value) {
            addCriterion("goods_img >=", value, "goodsImg");
            return (Criteria) this;
        }

        public Criteria andGoodsImgLessThan(String value) {
            addCriterion("goods_img <", value, "goodsImg");
            return (Criteria) this;
        }

        public Criteria andGoodsImgLessThanOrEqualTo(String value) {
            addCriterion("goods_img <=", value, "goodsImg");
            return (Criteria) this;
        }

        public Criteria andGoodsImgLike(String value) {
            addCriterion("goods_img like", value, "goodsImg");
            return (Criteria) this;
        }

        public Criteria andGoodsImgNotLike(String value) {
            addCriterion("goods_img not like", value, "goodsImg");
            return (Criteria) this;
        }

        public Criteria andGoodsImgIn(List<String> values) {
            addCriterion("goods_img in", values, "goodsImg");
            return (Criteria) this;
        }

        public Criteria andGoodsImgNotIn(List<String> values) {
            addCriterion("goods_img not in", values, "goodsImg");
            return (Criteria) this;
        }

        public Criteria andGoodsImgBetween(String value1, String value2) {
            addCriterion("goods_img between", value1, value2, "goodsImg");
            return (Criteria) this;
        }

        public Criteria andGoodsImgNotBetween(String value1, String value2) {
            addCriterion("goods_img not between", value1, value2, "goodsImg");
            return (Criteria) this;
        }

        public Criteria andGoodsSpecNameIsNull() {
            addCriterion("goods_spec_name is null");
            return (Criteria) this;
        }

        public Criteria andGoodsSpecNameIsNotNull() {
            addCriterion("goods_spec_name is not null");
            return (Criteria) this;
        }

        public Criteria andGoodsSpecNameEqualTo(String value) {
            addCriterion("goods_spec_name =", value, "goodsSpecName");
            return (Criteria) this;
        }

        public Criteria andGoodsSpecNameNotEqualTo(String value) {
            addCriterion("goods_spec_name <>", value, "goodsSpecName");
            return (Criteria) this;
        }

        public Criteria andGoodsSpecNameGreaterThan(String value) {
            addCriterion("goods_spec_name >", value, "goodsSpecName");
            return (Criteria) this;
        }

        public Criteria andGoodsSpecNameGreaterThanOrEqualTo(String value) {
            addCriterion("goods_spec_name >=", value, "goodsSpecName");
            return (Criteria) this;
        }

        public Criteria andGoodsSpecNameLessThan(String value) {
            addCriterion("goods_spec_name <", value, "goodsSpecName");
            return (Criteria) this;
        }

        public Criteria andGoodsSpecNameLessThanOrEqualTo(String value) {
            addCriterion("goods_spec_name <=", value, "goodsSpecName");
            return (Criteria) this;
        }

        public Criteria andGoodsSpecNameLike(String value) {
            addCriterion("goods_spec_name like", value, "goodsSpecName");
            return (Criteria) this;
        }

        public Criteria andGoodsSpecNameNotLike(String value) {
            addCriterion("goods_spec_name not like", value, "goodsSpecName");
            return (Criteria) this;
        }

        public Criteria andGoodsSpecNameIn(List<String> values) {
            addCriterion("goods_spec_name in", values, "goodsSpecName");
            return (Criteria) this;
        }

        public Criteria andGoodsSpecNameNotIn(List<String> values) {
            addCriterion("goods_spec_name not in", values, "goodsSpecName");
            return (Criteria) this;
        }

        public Criteria andGoodsSpecNameBetween(String value1, String value2) {
            addCriterion("goods_spec_name between", value1, value2, "goodsSpecName");
            return (Criteria) this;
        }

        public Criteria andGoodsSpecNameNotBetween(String value1, String value2) {
            addCriterion("goods_spec_name not between", value1, value2, "goodsSpecName");
            return (Criteria) this;
        }

        public Criteria andGoodsPriceIsNull() {
            addCriterion("goods_price is null");
            return (Criteria) this;
        }

        public Criteria andGoodsPriceIsNotNull() {
            addCriterion("goods_price is not null");
            return (Criteria) this;
        }

        public Criteria andGoodsPriceEqualTo(BigDecimal value) {
            addCriterion("goods_price =", value, "goodsPrice");
            return (Criteria) this;
        }

        public Criteria andGoodsPriceNotEqualTo(BigDecimal value) {
            addCriterion("goods_price <>", value, "goodsPrice");
            return (Criteria) this;
        }

        public Criteria andGoodsPriceGreaterThan(BigDecimal value) {
            addCriterion("goods_price >", value, "goodsPrice");
            return (Criteria) this;
        }

        public Criteria andGoodsPriceGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("goods_price >=", value, "goodsPrice");
            return (Criteria) this;
        }

        public Criteria andGoodsPriceLessThan(BigDecimal value) {
            addCriterion("goods_price <", value, "goodsPrice");
            return (Criteria) this;
        }

        public Criteria andGoodsPriceLessThanOrEqualTo(BigDecimal value) {
            addCriterion("goods_price <=", value, "goodsPrice");
            return (Criteria) this;
        }

        public Criteria andGoodsPriceIn(List<BigDecimal> values) {
            addCriterion("goods_price in", values, "goodsPrice");
            return (Criteria) this;
        }

        public Criteria andGoodsPriceNotIn(List<BigDecimal> values) {
            addCriterion("goods_price not in", values, "goodsPrice");
            return (Criteria) this;
        }

        public Criteria andGoodsPriceBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("goods_price between", value1, value2, "goodsPrice");
            return (Criteria) this;
        }

        public Criteria andGoodsPriceNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("goods_price not between", value1, value2, "goodsPrice");
            return (Criteria) this;
        }

        public Criteria andGoodsActualPriceIsNull() {
            addCriterion("goods_actual_price is null");
            return (Criteria) this;
        }

        public Criteria andGoodsActualPriceIsNotNull() {
            addCriterion("goods_actual_price is not null");
            return (Criteria) this;
        }

        public Criteria andGoodsActualPriceEqualTo(BigDecimal value) {
            addCriterion("goods_actual_price =", value, "goodsActualPrice");
            return (Criteria) this;
        }

        public Criteria andGoodsActualPriceNotEqualTo(BigDecimal value) {
            addCriterion("goods_actual_price <>", value, "goodsActualPrice");
            return (Criteria) this;
        }

        public Criteria andGoodsActualPriceGreaterThan(BigDecimal value) {
            addCriterion("goods_actual_price >", value, "goodsActualPrice");
            return (Criteria) this;
        }

        public Criteria andGoodsActualPriceGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("goods_actual_price >=", value, "goodsActualPrice");
            return (Criteria) this;
        }

        public Criteria andGoodsActualPriceLessThan(BigDecimal value) {
            addCriterion("goods_actual_price <", value, "goodsActualPrice");
            return (Criteria) this;
        }

        public Criteria andGoodsActualPriceLessThanOrEqualTo(BigDecimal value) {
            addCriterion("goods_actual_price <=", value, "goodsActualPrice");
            return (Criteria) this;
        }

        public Criteria andGoodsActualPriceIn(List<BigDecimal> values) {
            addCriterion("goods_actual_price in", values, "goodsActualPrice");
            return (Criteria) this;
        }

        public Criteria andGoodsActualPriceNotIn(List<BigDecimal> values) {
            addCriterion("goods_actual_price not in", values, "goodsActualPrice");
            return (Criteria) this;
        }

        public Criteria andGoodsActualPriceBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("goods_actual_price between", value1, value2, "goodsActualPrice");
            return (Criteria) this;
        }

        public Criteria andGoodsActualPriceNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("goods_actual_price not between", value1, value2, "goodsActualPrice");
            return (Criteria) this;
        }

        public Criteria andSaleCountIsNull() {
            addCriterion("sale_count is null");
            return (Criteria) this;
        }

        public Criteria andSaleCountIsNotNull() {
            addCriterion("sale_count is not null");
            return (Criteria) this;
        }

        public Criteria andSaleCountEqualTo(Integer value) {
            addCriterion("sale_count =", value, "saleCount");
            return (Criteria) this;
        }

        public Criteria andSaleCountNotEqualTo(Integer value) {
            addCriterion("sale_count <>", value, "saleCount");
            return (Criteria) this;
        }

        public Criteria andSaleCountGreaterThan(Integer value) {
            addCriterion("sale_count >", value, "saleCount");
            return (Criteria) this;
        }

        public Criteria andSaleCountGreaterThanOrEqualTo(Integer value) {
            addCriterion("sale_count >=", value, "saleCount");
            return (Criteria) this;
        }

        public Criteria andSaleCountLessThan(Integer value) {
            addCriterion("sale_count <", value, "saleCount");
            return (Criteria) this;
        }

        public Criteria andSaleCountLessThanOrEqualTo(Integer value) {
            addCriterion("sale_count <=", value, "saleCount");
            return (Criteria) this;
        }

        public Criteria andSaleCountIn(List<Integer> values) {
            addCriterion("sale_count in", values, "saleCount");
            return (Criteria) this;
        }

        public Criteria andSaleCountNotIn(List<Integer> values) {
            addCriterion("sale_count not in", values, "saleCount");
            return (Criteria) this;
        }

        public Criteria andSaleCountBetween(Integer value1, Integer value2) {
            addCriterion("sale_count between", value1, value2, "saleCount");
            return (Criteria) this;
        }

        public Criteria andSaleCountNotBetween(Integer value1, Integer value2) {
            addCriterion("sale_count not between", value1, value2, "saleCount");
            return (Criteria) this;
        }

        public Criteria andTotalPriceIsNull() {
            addCriterion("total_price is null");
            return (Criteria) this;
        }

        public Criteria andTotalPriceIsNotNull() {
            addCriterion("total_price is not null");
            return (Criteria) this;
        }

        public Criteria andTotalPriceEqualTo(BigDecimal value) {
            addCriterion("total_price =", value, "totalPrice");
            return (Criteria) this;
        }

        public Criteria andTotalPriceNotEqualTo(BigDecimal value) {
            addCriterion("total_price <>", value, "totalPrice");
            return (Criteria) this;
        }

        public Criteria andTotalPriceGreaterThan(BigDecimal value) {
            addCriterion("total_price >", value, "totalPrice");
            return (Criteria) this;
        }

        public Criteria andTotalPriceGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("total_price >=", value, "totalPrice");
            return (Criteria) this;
        }

        public Criteria andTotalPriceLessThan(BigDecimal value) {
            addCriterion("total_price <", value, "totalPrice");
            return (Criteria) this;
        }

        public Criteria andTotalPriceLessThanOrEqualTo(BigDecimal value) {
            addCriterion("total_price <=", value, "totalPrice");
            return (Criteria) this;
        }

        public Criteria andTotalPriceIn(List<BigDecimal> values) {
            addCriterion("total_price in", values, "totalPrice");
            return (Criteria) this;
        }

        public Criteria andTotalPriceNotIn(List<BigDecimal> values) {
            addCriterion("total_price not in", values, "totalPrice");
            return (Criteria) this;
        }

        public Criteria andTotalPriceBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("total_price between", value1, value2, "totalPrice");
            return (Criteria) this;
        }

        public Criteria andTotalPriceNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("total_price not between", value1, value2, "totalPrice");
            return (Criteria) this;
        }

        public Criteria andGiveawayTypeIsNull() {
            addCriterion("giveaway_type is null");
            return (Criteria) this;
        }

        public Criteria andGiveawayTypeIsNotNull() {
            addCriterion("giveaway_type is not null");
            return (Criteria) this;
        }

        public Criteria andGiveawayTypeEqualTo(Boolean value) {
            addCriterion("giveaway_type =", value, "giveawayType");
            return (Criteria) this;
        }

        public Criteria andGiveawayTypeNotEqualTo(Boolean value) {
            addCriterion("giveaway_type <>", value, "giveawayType");
            return (Criteria) this;
        }

        public Criteria andGiveawayTypeGreaterThan(Boolean value) {
            addCriterion("giveaway_type >", value, "giveawayType");
            return (Criteria) this;
        }

        public Criteria andGiveawayTypeGreaterThanOrEqualTo(Boolean value) {
            addCriterion("giveaway_type >=", value, "giveawayType");
            return (Criteria) this;
        }

        public Criteria andGiveawayTypeLessThan(Boolean value) {
            addCriterion("giveaway_type <", value, "giveawayType");
            return (Criteria) this;
        }

        public Criteria andGiveawayTypeLessThanOrEqualTo(Boolean value) {
            addCriterion("giveaway_type <=", value, "giveawayType");
            return (Criteria) this;
        }

        public Criteria andGiveawayTypeIn(List<Boolean> values) {
            addCriterion("giveaway_type in", values, "giveawayType");
            return (Criteria) this;
        }

        public Criteria andGiveawayTypeNotIn(List<Boolean> values) {
            addCriterion("giveaway_type not in", values, "giveawayType");
            return (Criteria) this;
        }

        public Criteria andGiveawayTypeBetween(Boolean value1, Boolean value2) {
            addCriterion("giveaway_type between", value1, value2, "giveawayType");
            return (Criteria) this;
        }

        public Criteria andGiveawayTypeNotBetween(Boolean value1, Boolean value2) {
            addCriterion("giveaway_type not between", value1, value2, "giveawayType");
            return (Criteria) this;
        }

        public Criteria andChildOrdeStatusIsNull() {
            addCriterion("child_orde_status is null");
            return (Criteria) this;
        }

        public Criteria andChildOrdeStatusIsNotNull() {
            addCriterion("child_orde_status is not null");
            return (Criteria) this;
        }

        public Criteria andChildOrdeStatusEqualTo(Integer value) {
            addCriterion("child_orde_status =", value, "childOrdeStatus");
            return (Criteria) this;
        }

        public Criteria andChildOrdeStatusNotEqualTo(Integer value) {
            addCriterion("child_orde_status <>", value, "childOrdeStatus");
            return (Criteria) this;
        }

        public Criteria andChildOrdeStatusGreaterThan(Integer value) {
            addCriterion("child_orde_status >", value, "childOrdeStatus");
            return (Criteria) this;
        }

        public Criteria andChildOrdeStatusGreaterThanOrEqualTo(Integer value) {
            addCriterion("child_orde_status >=", value, "childOrdeStatus");
            return (Criteria) this;
        }

        public Criteria andChildOrdeStatusLessThan(Integer value) {
            addCriterion("child_orde_status <", value, "childOrdeStatus");
            return (Criteria) this;
        }

        public Criteria andChildOrdeStatusLessThanOrEqualTo(Integer value) {
            addCriterion("child_orde_status <=", value, "childOrdeStatus");
            return (Criteria) this;
        }

        public Criteria andChildOrdeStatusIn(List<Integer> values) {
            addCriterion("child_orde_status in", values, "childOrdeStatus");
            return (Criteria) this;
        }

        public Criteria andChildOrdeStatusNotIn(List<Integer> values) {
            addCriterion("child_orde_status not in", values, "childOrdeStatus");
            return (Criteria) this;
        }

        public Criteria andChildOrdeStatusBetween(Integer value1, Integer value2) {
            addCriterion("child_orde_status between", value1, value2, "childOrdeStatus");
            return (Criteria) this;
        }

        public Criteria andChildOrdeStatusNotBetween(Integer value1, Integer value2) {
            addCriterion("child_orde_status not between", value1, value2, "childOrdeStatus");
            return (Criteria) this;
        }

        public Criteria andPraiseStatusIsNull() {
            addCriterion("praise_status is null");
            return (Criteria) this;
        }

        public Criteria andPraiseStatusIsNotNull() {
            addCriterion("praise_status is not null");
            return (Criteria) this;
        }

        public Criteria andPraiseStatusEqualTo(Integer value) {
            addCriterion("praise_status =", value, "praiseStatus");
            return (Criteria) this;
        }

        public Criteria andPraiseStatusNotEqualTo(Integer value) {
            addCriterion("praise_status <>", value, "praiseStatus");
            return (Criteria) this;
        }

        public Criteria andPraiseStatusGreaterThan(Integer value) {
            addCriterion("praise_status >", value, "praiseStatus");
            return (Criteria) this;
        }

        public Criteria andPraiseStatusGreaterThanOrEqualTo(Integer value) {
            addCriterion("praise_status >=", value, "praiseStatus");
            return (Criteria) this;
        }

        public Criteria andPraiseStatusLessThan(Integer value) {
            addCriterion("praise_status <", value, "praiseStatus");
            return (Criteria) this;
        }

        public Criteria andPraiseStatusLessThanOrEqualTo(Integer value) {
            addCriterion("praise_status <=", value, "praiseStatus");
            return (Criteria) this;
        }

        public Criteria andPraiseStatusIn(List<Integer> values) {
            addCriterion("praise_status in", values, "praiseStatus");
            return (Criteria) this;
        }

        public Criteria andPraiseStatusNotIn(List<Integer> values) {
            addCriterion("praise_status not in", values, "praiseStatus");
            return (Criteria) this;
        }

        public Criteria andPraiseStatusBetween(Integer value1, Integer value2) {
            addCriterion("praise_status between", value1, value2, "praiseStatus");
            return (Criteria) this;
        }

        public Criteria andPraiseStatusNotBetween(Integer value1, Integer value2) {
            addCriterion("praise_status not between", value1, value2, "praiseStatus");
            return (Criteria) this;
        }

        public Criteria andGasOilNoIsNull() {
            addCriterion("gas_oil_no is null");
            return (Criteria) this;
        }

        public Criteria andGasOilNoIsNotNull() {
            addCriterion("gas_oil_no is not null");
            return (Criteria) this;
        }

        public Criteria andGasOilNoEqualTo(String value) {
            addCriterion("gas_oil_no =", value, "gasOilNo");
            return (Criteria) this;
        }

        public Criteria andGasOilNoNotEqualTo(String value) {
            addCriterion("gas_oil_no <>", value, "gasOilNo");
            return (Criteria) this;
        }

        public Criteria andGasOilNoGreaterThan(String value) {
            addCriterion("gas_oil_no >", value, "gasOilNo");
            return (Criteria) this;
        }

        public Criteria andGasOilNoGreaterThanOrEqualTo(String value) {
            addCriterion("gas_oil_no >=", value, "gasOilNo");
            return (Criteria) this;
        }

        public Criteria andGasOilNoLessThan(String value) {
            addCriterion("gas_oil_no <", value, "gasOilNo");
            return (Criteria) this;
        }

        public Criteria andGasOilNoLessThanOrEqualTo(String value) {
            addCriterion("gas_oil_no <=", value, "gasOilNo");
            return (Criteria) this;
        }

        public Criteria andGasOilNoLike(String value) {
            addCriterion("gas_oil_no like", value, "gasOilNo");
            return (Criteria) this;
        }

        public Criteria andGasOilNoNotLike(String value) {
            addCriterion("gas_oil_no not like", value, "gasOilNo");
            return (Criteria) this;
        }

        public Criteria andGasOilNoIn(List<String> values) {
            addCriterion("gas_oil_no in", values, "gasOilNo");
            return (Criteria) this;
        }

        public Criteria andGasOilNoNotIn(List<String> values) {
            addCriterion("gas_oil_no not in", values, "gasOilNo");
            return (Criteria) this;
        }

        public Criteria andGasOilNoBetween(String value1, String value2) {
            addCriterion("gas_oil_no between", value1, value2, "gasOilNo");
            return (Criteria) this;
        }

        public Criteria andGasOilNoNotBetween(String value1, String value2) {
            addCriterion("gas_oil_no not between", value1, value2, "gasOilNo");
            return (Criteria) this;
        }

        public Criteria andGasGunNoIsNull() {
            addCriterion("gas_gun_no is null");
            return (Criteria) this;
        }

        public Criteria andGasGunNoIsNotNull() {
            addCriterion("gas_gun_no is not null");
            return (Criteria) this;
        }

        public Criteria andGasGunNoEqualTo(String value) {
            addCriterion("gas_gun_no =", value, "gasGunNo");
            return (Criteria) this;
        }

        public Criteria andGasGunNoNotEqualTo(String value) {
            addCriterion("gas_gun_no <>", value, "gasGunNo");
            return (Criteria) this;
        }

        public Criteria andGasGunNoGreaterThan(String value) {
            addCriterion("gas_gun_no >", value, "gasGunNo");
            return (Criteria) this;
        }

        public Criteria andGasGunNoGreaterThanOrEqualTo(String value) {
            addCriterion("gas_gun_no >=", value, "gasGunNo");
            return (Criteria) this;
        }

        public Criteria andGasGunNoLessThan(String value) {
            addCriterion("gas_gun_no <", value, "gasGunNo");
            return (Criteria) this;
        }

        public Criteria andGasGunNoLessThanOrEqualTo(String value) {
            addCriterion("gas_gun_no <=", value, "gasGunNo");
            return (Criteria) this;
        }

        public Criteria andGasGunNoLike(String value) {
            addCriterion("gas_gun_no like", value, "gasGunNo");
            return (Criteria) this;
        }

        public Criteria andGasGunNoNotLike(String value) {
            addCriterion("gas_gun_no not like", value, "gasGunNo");
            return (Criteria) this;
        }

        public Criteria andGasGunNoIn(List<String> values) {
            addCriterion("gas_gun_no in", values, "gasGunNo");
            return (Criteria) this;
        }

        public Criteria andGasGunNoNotIn(List<String> values) {
            addCriterion("gas_gun_no not in", values, "gasGunNo");
            return (Criteria) this;
        }

        public Criteria andGasGunNoBetween(String value1, String value2) {
            addCriterion("gas_gun_no between", value1, value2, "gasGunNo");
            return (Criteria) this;
        }

        public Criteria andGasGunNoNotBetween(String value1, String value2) {
            addCriterion("gas_gun_no not between", value1, value2, "gasGunNo");
            return (Criteria) this;
        }

        public Criteria andGasOilTypeIsNull() {
            addCriterion("gas_oil_type is null");
            return (Criteria) this;
        }

        public Criteria andGasOilTypeIsNotNull() {
            addCriterion("gas_oil_type is not null");
            return (Criteria) this;
        }

        public Criteria andGasOilTypeEqualTo(Integer value) {
            addCriterion("gas_oil_type =", value, "gasOilType");
            return (Criteria) this;
        }

        public Criteria andGasOilTypeNotEqualTo(Integer value) {
            addCriterion("gas_oil_type <>", value, "gasOilType");
            return (Criteria) this;
        }

        public Criteria andGasOilTypeGreaterThan(Integer value) {
            addCriterion("gas_oil_type >", value, "gasOilType");
            return (Criteria) this;
        }

        public Criteria andGasOilTypeGreaterThanOrEqualTo(Integer value) {
            addCriterion("gas_oil_type >=", value, "gasOilType");
            return (Criteria) this;
        }

        public Criteria andGasOilTypeLessThan(Integer value) {
            addCriterion("gas_oil_type <", value, "gasOilType");
            return (Criteria) this;
        }

        public Criteria andGasOilTypeLessThanOrEqualTo(Integer value) {
            addCriterion("gas_oil_type <=", value, "gasOilType");
            return (Criteria) this;
        }

        public Criteria andGasOilTypeIn(List<Integer> values) {
            addCriterion("gas_oil_type in", values, "gasOilType");
            return (Criteria) this;
        }

        public Criteria andGasOilTypeNotIn(List<Integer> values) {
            addCriterion("gas_oil_type not in", values, "gasOilType");
            return (Criteria) this;
        }

        public Criteria andGasOilTypeBetween(Integer value1, Integer value2) {
            addCriterion("gas_oil_type between", value1, value2, "gasOilType");
            return (Criteria) this;
        }

        public Criteria andGasOilTypeNotBetween(Integer value1, Integer value2) {
            addCriterion("gas_oil_type not between", value1, value2, "gasOilType");
            return (Criteria) this;
        }

        public Criteria andGasOrderNoIsNull() {
            addCriterion("gas_order_no is null");
            return (Criteria) this;
        }

        public Criteria andGasOrderNoIsNotNull() {
            addCriterion("gas_order_no is not null");
            return (Criteria) this;
        }

        public Criteria andGasOrderNoEqualTo(String value) {
            addCriterion("gas_order_no =", value, "gasOrderNo");
            return (Criteria) this;
        }

        public Criteria andGasOrderNoNotEqualTo(String value) {
            addCriterion("gas_order_no <>", value, "gasOrderNo");
            return (Criteria) this;
        }

        public Criteria andGasOrderNoGreaterThan(String value) {
            addCriterion("gas_order_no >", value, "gasOrderNo");
            return (Criteria) this;
        }

        public Criteria andGasOrderNoGreaterThanOrEqualTo(String value) {
            addCriterion("gas_order_no >=", value, "gasOrderNo");
            return (Criteria) this;
        }

        public Criteria andGasOrderNoLessThan(String value) {
            addCriterion("gas_order_no <", value, "gasOrderNo");
            return (Criteria) this;
        }

        public Criteria andGasOrderNoLessThanOrEqualTo(String value) {
            addCriterion("gas_order_no <=", value, "gasOrderNo");
            return (Criteria) this;
        }

        public Criteria andGasOrderNoLike(String value) {
            addCriterion("gas_order_no like", value, "gasOrderNo");
            return (Criteria) this;
        }

        public Criteria andGasOrderNoNotLike(String value) {
            addCriterion("gas_order_no not like", value, "gasOrderNo");
            return (Criteria) this;
        }

        public Criteria andGasOrderNoIn(List<String> values) {
            addCriterion("gas_order_no in", values, "gasOrderNo");
            return (Criteria) this;
        }

        public Criteria andGasOrderNoNotIn(List<String> values) {
            addCriterion("gas_order_no not in", values, "gasOrderNo");
            return (Criteria) this;
        }

        public Criteria andGasOrderNoBetween(String value1, String value2) {
            addCriterion("gas_order_no between", value1, value2, "gasOrderNo");
            return (Criteria) this;
        }

        public Criteria andGasOrderNoNotBetween(String value1, String value2) {
            addCriterion("gas_order_no not between", value1, value2, "gasOrderNo");
            return (Criteria) this;
        }

        public Criteria andGasPriceGunIsNull() {
            addCriterion("gas_price_gun is null");
            return (Criteria) this;
        }

        public Criteria andGasPriceGunIsNotNull() {
            addCriterion("gas_price_gun is not null");
            return (Criteria) this;
        }

        public Criteria andGasPriceGunEqualTo(BigDecimal value) {
            addCriterion("gas_price_gun =", value, "gasPriceGun");
            return (Criteria) this;
        }

        public Criteria andGasPriceGunNotEqualTo(BigDecimal value) {
            addCriterion("gas_price_gun <>", value, "gasPriceGun");
            return (Criteria) this;
        }

        public Criteria andGasPriceGunGreaterThan(BigDecimal value) {
            addCriterion("gas_price_gun >", value, "gasPriceGun");
            return (Criteria) this;
        }

        public Criteria andGasPriceGunGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("gas_price_gun >=", value, "gasPriceGun");
            return (Criteria) this;
        }

        public Criteria andGasPriceGunLessThan(BigDecimal value) {
            addCriterion("gas_price_gun <", value, "gasPriceGun");
            return (Criteria) this;
        }

        public Criteria andGasPriceGunLessThanOrEqualTo(BigDecimal value) {
            addCriterion("gas_price_gun <=", value, "gasPriceGun");
            return (Criteria) this;
        }

        public Criteria andGasPriceGunIn(List<BigDecimal> values) {
            addCriterion("gas_price_gun in", values, "gasPriceGun");
            return (Criteria) this;
        }

        public Criteria andGasPriceGunNotIn(List<BigDecimal> values) {
            addCriterion("gas_price_gun not in", values, "gasPriceGun");
            return (Criteria) this;
        }

        public Criteria andGasPriceGunBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("gas_price_gun between", value1, value2, "gasPriceGun");
            return (Criteria) this;
        }

        public Criteria andGasPriceGunNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("gas_price_gun not between", value1, value2, "gasPriceGun");
            return (Criteria) this;
        }

        public Criteria andGasPriceVipIsNull() {
            addCriterion("gas_price_vip is null");
            return (Criteria) this;
        }

        public Criteria andGasPriceVipIsNotNull() {
            addCriterion("gas_price_vip is not null");
            return (Criteria) this;
        }

        public Criteria andGasPriceVipEqualTo(BigDecimal value) {
            addCriterion("gas_price_vip =", value, "gasPriceVip");
            return (Criteria) this;
        }

        public Criteria andGasPriceVipNotEqualTo(BigDecimal value) {
            addCriterion("gas_price_vip <>", value, "gasPriceVip");
            return (Criteria) this;
        }

        public Criteria andGasPriceVipGreaterThan(BigDecimal value) {
            addCriterion("gas_price_vip >", value, "gasPriceVip");
            return (Criteria) this;
        }

        public Criteria andGasPriceVipGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("gas_price_vip >=", value, "gasPriceVip");
            return (Criteria) this;
        }

        public Criteria andGasPriceVipLessThan(BigDecimal value) {
            addCriterion("gas_price_vip <", value, "gasPriceVip");
            return (Criteria) this;
        }

        public Criteria andGasPriceVipLessThanOrEqualTo(BigDecimal value) {
            addCriterion("gas_price_vip <=", value, "gasPriceVip");
            return (Criteria) this;
        }

        public Criteria andGasPriceVipIn(List<BigDecimal> values) {
            addCriterion("gas_price_vip in", values, "gasPriceVip");
            return (Criteria) this;
        }

        public Criteria andGasPriceVipNotIn(List<BigDecimal> values) {
            addCriterion("gas_price_vip not in", values, "gasPriceVip");
            return (Criteria) this;
        }

        public Criteria andGasPriceVipBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("gas_price_vip between", value1, value2, "gasPriceVip");
            return (Criteria) this;
        }

        public Criteria andGasPriceVipNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("gas_price_vip not between", value1, value2, "gasPriceVip");
            return (Criteria) this;
        }

        public Criteria andExt1IsNull() {
            addCriterion("ext_1 is null");
            return (Criteria) this;
        }

        public Criteria andExt1IsNotNull() {
            addCriterion("ext_1 is not null");
            return (Criteria) this;
        }

        public Criteria andExt1EqualTo(String value) {
            addCriterion("ext_1 =", value, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1NotEqualTo(String value) {
            addCriterion("ext_1 <>", value, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1GreaterThan(String value) {
            addCriterion("ext_1 >", value, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1GreaterThanOrEqualTo(String value) {
            addCriterion("ext_1 >=", value, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1LessThan(String value) {
            addCriterion("ext_1 <", value, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1LessThanOrEqualTo(String value) {
            addCriterion("ext_1 <=", value, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1Like(String value) {
            addCriterion("ext_1 like", value, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1NotLike(String value) {
            addCriterion("ext_1 not like", value, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1In(List<String> values) {
            addCriterion("ext_1 in", values, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1NotIn(List<String> values) {
            addCriterion("ext_1 not in", values, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1Between(String value1, String value2) {
            addCriterion("ext_1 between", value1, value2, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1NotBetween(String value1, String value2) {
            addCriterion("ext_1 not between", value1, value2, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt2IsNull() {
            addCriterion("ext_2 is null");
            return (Criteria) this;
        }

        public Criteria andExt2IsNotNull() {
            addCriterion("ext_2 is not null");
            return (Criteria) this;
        }

        public Criteria andExt2EqualTo(String value) {
            addCriterion("ext_2 =", value, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2NotEqualTo(String value) {
            addCriterion("ext_2 <>", value, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2GreaterThan(String value) {
            addCriterion("ext_2 >", value, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2GreaterThanOrEqualTo(String value) {
            addCriterion("ext_2 >=", value, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2LessThan(String value) {
            addCriterion("ext_2 <", value, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2LessThanOrEqualTo(String value) {
            addCriterion("ext_2 <=", value, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2Like(String value) {
            addCriterion("ext_2 like", value, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2NotLike(String value) {
            addCriterion("ext_2 not like", value, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2In(List<String> values) {
            addCriterion("ext_2 in", values, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2NotIn(List<String> values) {
            addCriterion("ext_2 not in", values, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2Between(String value1, String value2) {
            addCriterion("ext_2 between", value1, value2, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2NotBetween(String value1, String value2) {
            addCriterion("ext_2 not between", value1, value2, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt3IsNull() {
            addCriterion("ext_3 is null");
            return (Criteria) this;
        }

        public Criteria andExt3IsNotNull() {
            addCriterion("ext_3 is not null");
            return (Criteria) this;
        }

        public Criteria andExt3EqualTo(String value) {
            addCriterion("ext_3 =", value, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3NotEqualTo(String value) {
            addCriterion("ext_3 <>", value, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3GreaterThan(String value) {
            addCriterion("ext_3 >", value, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3GreaterThanOrEqualTo(String value) {
            addCriterion("ext_3 >=", value, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3LessThan(String value) {
            addCriterion("ext_3 <", value, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3LessThanOrEqualTo(String value) {
            addCriterion("ext_3 <=", value, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3Like(String value) {
            addCriterion("ext_3 like", value, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3NotLike(String value) {
            addCriterion("ext_3 not like", value, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3In(List<String> values) {
            addCriterion("ext_3 in", values, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3NotIn(List<String> values) {
            addCriterion("ext_3 not in", values, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3Between(String value1, String value2) {
            addCriterion("ext_3 between", value1, value2, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3NotBetween(String value1, String value2) {
            addCriterion("ext_3 not between", value1, value2, "ext3");
            return (Criteria) this;
        }
    }

    /**
     */
    public static class Criteria extends GeneratedCriteria {

        protected Criteria() {
            super();
        }
    }

    public static class Criterion {
        private String condition;

        private Object value;

        private Object secondValue;

        private boolean noValue;

        private boolean singleValue;

        private boolean betweenValue;

        private boolean listValue;

        private String typeHandler;

        public String getCondition() {
            return condition;
        }

        public Object getValue() {
            return value;
        }

        public Object getSecondValue() {
            return secondValue;
        }

        public boolean isNoValue() {
            return noValue;
        }

        public boolean isSingleValue() {
            return singleValue;
        }

        public boolean isBetweenValue() {
            return betweenValue;
        }

        public boolean isListValue() {
            return listValue;
        }

        public String getTypeHandler() {
            return typeHandler;
        }

        protected Criterion(String condition) {
            super();
            this.condition = condition;
            this.typeHandler = null;
            this.noValue = true;
        }

        protected Criterion(String condition, Object value, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.typeHandler = typeHandler;
            if (value instanceof List<?>) {
                this.listValue = true;
            } else {
                this.singleValue = true;
            }
        }

        protected Criterion(String condition, Object value) {
            this(condition, value, null);
        }

        protected Criterion(String condition, Object value, Object secondValue, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.secondValue = secondValue;
            this.typeHandler = typeHandler;
            this.betweenValue = true;
        }

        protected Criterion(String condition, Object value, Object secondValue) {
            this(condition, value, secondValue, null);
        }
    }
}